#ifndef _EXTRACT_FUNCTIONS_H_
#define _EXTRACT_FUNCTIONS_H_

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <set>
#include <string>
#include <fstream>
#include "seqdb.h"
#include "BioSequence.h"

using namespace std;

typedef set<string> NAMESET;

//========================================================
int extract_forward(FILE* infile, const char* name, long n_from, long n_to, FILE* outfile);
//========================================================
int extract_backward(FILE* infile, const char* name, long n_from, long n_to, FILE* outfile);
//========================================================
int extract(FILE* infile, const char* name, long n_from, long n_to, FILE* outfile);
//========================================================
int extract(FILE* ifs, const char* sName, long iFrom, long iTo, BioSubSequence& sSeq);
//========================================================
int extract(ifstream* ifs, const char* sName, long n_from, long n_to, BioSubSequence& seq);
//========================================================
void cleanRecord(char *pcLine);
//========================================================
int loadIndex(FILE *F, POSMAP &pmap);
//========================================================
void saveIndex(FILE *F, const POSMAP &pmap);
//========================================================
FILE* findLocus_File(FILE *INF, const char *pcFName, const char *pLName, POSMAP &pmap);
//========================================================
FILE* findLocus_Map(const char *pLName, const POSMAP &pmap);
//========================================================
FILE *getLocus(FILE *FIN, const char *pcFName, const char *pLName, POSMAP &pmap);
//========================================================
int buildIndex(FILE *INF, const char *pcFName, POSMAP &pmap);
//========================================================
void doExtract(FILE *FMAP, FILE *FIN, const char *pcFName, FILE *FOUT, POSMAP &pmap);
//========================================================

#endif //_EXTRACT_FUNCTIONS_H_
